# This file was auto-generated by Fern from our API Definition.

from ..core.pydantic_utilities import UniversalBaseModel
import typing
from .prompt import Prompt
from .language import Language
from .agent_actions_item import AgentActionsItem
from .agent_voice import AgentVoice
from .webhook import Webhook
from .pinecone_vector_database import PineconeVectorDatabase
from .interrupt_sensitivity import InterruptSensitivity
from .agent_endpointing_sensitivity import AgentEndpointingSensitivity
from .agent_ivr_navigation_mode import AgentIvrNavigationMode
from .open_ai_account_connection import OpenAiAccountConnection
from .internal_llm_fallback import InternalLlmFallback
from .agent_deepgram_keywords_value import AgentDeepgramKeywordsValue
from ..core.pydantic_utilities import IS_PYDANTIC_V2
import pydantic


class Agent(UniversalBaseModel):
    id: str
    user_id: str
    name: typing.Optional[str] = None
    prompt: Prompt
    language: typing.Optional[Language] = None
    actions: typing.List[AgentActionsItem]
    voice: AgentVoice
    initial_message: typing.Optional[str] = None
    webhook: typing.Optional[Webhook] = None
    vector_database: typing.Optional[PineconeVectorDatabase] = None
    interrupt_sensitivity: typing.Optional[InterruptSensitivity] = None
    context_endpoint: typing.Optional[str] = None
    noise_suppression: typing.Optional[bool] = None
    endpointing_sensitivity: typing.Optional[AgentEndpointingSensitivity] = None
    ivr_navigation_mode: typing.Optional[AgentIvrNavigationMode] = None
    conversation_speed: typing.Optional[float] = None
    initial_message_delay: typing.Optional[float] = None
    openai_model_name_override: typing.Optional[str] = None
    ask_if_human_present_on_idle: typing.Optional[bool] = None
    openai_account_connection: typing.Optional[OpenAiAccountConnection] = None
    run_do_not_call_detection: typing.Optional[bool] = None
    llm_fallback: typing.Optional[InternalLlmFallback] = None
    deepgram_keywords: typing.Optional[typing.Dict[str, typing.Optional[AgentDeepgramKeywordsValue]]] = None
    idle_time_seconds: typing.Optional[int] = None
    llm_temperature: typing.Optional[float] = None

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
